#include <signal.h>

int sybaction(int signum, 
	      const struct sigaction *act, 
	      struct sigaction *oldact) 
{
  struct sigaction realact;
  struct sigaction realoldact;

  int * ipf, * ipt;
  int ret;

  ipf = (int *) act;
  ipt = (int *) &realact;

  *ipt = *ipf;
  *(ipt+1) = *(ipf+1);
  *(ipt+33) = *(ipf+2);
  *(ipt+34) = *(ipf+3);

  ret = sigaction(signum, &realact, &realoldact);

  ipf = (int *) &realoldact;
  ipt = (int *) oldact;

  *ipt = *ipf;
  *(ipt+1) = *(ipf+1);
  *(ipt+2) = *(ipf+33);
  *(ipt+3) = *(ipf+34);

  return ret;
}
